searchNodes=[{"doc":"Surface is component based library for Phoenix LiveView.Built on top of the new Phoenix.LiveComponent API, Surface provides a more declarative way to express and use components in Phoenix.Full documentation and live examples can be found at surface-demo.msaraiva.ioThis module defines the ~H sigil that should be used to translate Surface code into Phoenix templates.In order to have ~H available for any Phoenix view, add the following import to your web file in lib/my_app_web.ex:# lib/my_app_web.ex ... def view do quote do ... import Surface end endDefining componentsTo create a component you need to define a module and use one of the available component types:Surface.Component - A stateless component.Surface.LiveComponent - A live stateful component.Surface.LiveView - A wrapper component around Phoenix.LiveView.Surface.MacroComponent - A low-level component which is responsible for translating its own content at compile time.Example# A functional stateless component defmodule Button do use Surface.Component property click, :event property kind, :string, default: &quot;is-info&quot; def render(assigns) do ~H&quot;&quot;&quot; &lt;button class=&quot;button {{ @kind }}&quot; phx-click={{ @click }}&gt; &lt;slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end endYou can visit the documentation of each type of component for further explanation and examples.","ref":"Surface.html","title":"Surface","type":"module"},{"doc":"","ref":"Surface.html#component/3","title":"Surface.component/3","type":"function"},{"doc":"Retrieve the component's config based on the key","ref":"Surface.html#get_config/1","title":"Surface.get_config/1","type":"macro"},{"doc":"Retrieve a component's config based on the key","ref":"Surface.html#get_config/2","title":"Surface.get_config/2","type":"macro"},{"doc":"Translates Surface code into Phoenix templates.","ref":"Surface.html#sigil_H/2","title":"Surface.sigil_H/2","type":"macro"},{"doc":"Defines a stateless component.Exampledefmodule Button do use Surface.Component property click, :event def render(assigns) do ~H&quot;&quot;&quot; &lt;button class=&quot;button&quot; phx-click={{ @click }}&gt; &lt;slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end endNote: Stateless components cannot handle Phoenix LiveView events. If you need to handle them, please use a Surface.LiveComponent instead.","ref":"Surface.Component.html","title":"Surface.Component","type":"behaviour"},{"doc":"This optional callback is invoked in order to set up a context that can be retrieved for any descendent component.","ref":"Surface.Component.html#c:init_context/1","title":"Surface.Component.init_context/1","type":"callback"},{"doc":"Defines a form that lets the user submit information.Provides a wrapper for Phoenix.HTML.Form.form_for/3. Additionally, adds the form instance that is returned by form_for/3 into the context, making it available to any child input.All options passed via opts will be sent to form_for/3, for and action can be set directly and will override anything in opts.Propertiesfor :any, required: true - Atom or changeset to inform the form data.action :string, default: &quot;#&quot; - URL to where the form is submitted.opts :keyword, default: [] - Keyword list with options to be passed down to form_for/3.change :event - Triggered when the form is changed.submit :event - Triggered when the form is submitted.","ref":"Surface.Components.Form.html","title":"Surface.Components.Form","type":"module"},{"doc":"Callback implementation for Surface.Component.init_context/1.","ref":"Surface.Components.Form.html#init_context/1","title":"Surface.Components.Form.init_context/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.html#render/1","title":"Surface.Components.Form.render/1","type":"function"},{"doc":"An input field that let the user specify a color, either with a text field or a color picker interface.Provides a wrapper for Phoenix.HTML.Form's color_input/3 function.All options passed via opts will be sent to color_input/3, value and class can be set directly and will override anything in opts.Examples&lt;ColorInput form=&quot;user&quot; field=&quot;color&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.ColorInput.html","title":"Surface.Components.Form.ColorInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.ColorInput.html#render/1","title":"Surface.Components.Form.ColorInput.render/1","type":"function"},{"doc":"An input field that let the user enter a date, either with a text field or a date picker interface.Provides a wrapper for Phoenix.HTML.Form's date_input/3 function.All options passed via opts will be sent to date_input/3, value and class can be set directly and will override anything in opts.Examples&lt;DateInput form=&quot;user&quot; field=&quot;birthday&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.DateInput.html","title":"Surface.Components.Form.DateInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateInput.html#render/1","title":"Surface.Components.Form.DateInput.render/1","type":"function"},{"doc":"An input field that let the user enter both date and time, using a text field and a date picker interface.Provides a wrapper for Phoenix.HTML.Form's datetime_local_input/3 function.All options passed via opts will be sent to datetime_local_input/3, value and class can be set directly and will override anything in opts.Examples&lt;DateTimeLocalInput form=&quot;order&quot; field=&quot;completed_at&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.DateTimeLocalInput.html","title":"Surface.Components.Form.DateTimeLocalInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateTimeLocalInput.html#render/1","title":"Surface.Components.Form.DateTimeLocalInput.render/1","type":"function"},{"doc":"An input field that let the user enter one or multiple e-mails.Provides a wrapper for Phoenix.HTML.Form's email_input/3 function.All options passed via opts will be sent to email_input/3, value and class can be set directly and will override anything in opts.Examples&lt;EmailInput form=&quot;user&quot; field=&quot;email&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.EmailInput.html","title":"Surface.Components.Form.EmailInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.EmailInput.html#render/1","title":"Surface.Components.Form.EmailInput.render/1","type":"function"},{"doc":"Defines a form field.The Field component sets the provided field name into the context so child components like input fields and labels can retrieve it and use it as the default field.Propertiesname :string, required: true - The field name.class :css_class - The CSS class for the generated &lt;div&gt; element.","ref":"Surface.Components.Form.Field.html","title":"Surface.Components.Form.Field","type":"module"},{"doc":"Callback implementation for Surface.Component.init_context/1.","ref":"Surface.Components.Form.Field.html#init_context/1","title":"Surface.Components.Form.Field.init_context/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Field.html#render/1","title":"Surface.Components.Form.Field.render/1","type":"function"},{"doc":"A hidden input field.Provides a wrapper for Phoenix.HTML.Form's hidden_input/3 function.All options passed via opts will be sent to hidden_input/3, value and class can be set directly and will override anything in opts.Examples&lt;HiddenInput form=&quot;user&quot; field=&quot;token&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.HiddenInput.html","title":"Surface.Components.Form.HiddenInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.HiddenInput.html#render/1","title":"Surface.Components.Form.HiddenInput.render/1","type":"function"},{"doc":"Defines a label.Provides a wrapper for Phoenix.HTML.Form's label/3 function.All options passed via opts will be sent to label/3, class can be set directly and will override anything in opts.Propertiesform :form - The form identifier.field :string - The field name.class :css_class - The CSS class for the underlying tag.opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.Label.html","title":"Surface.Components.Form.Label","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Label.html#render/1","title":"Surface.Components.Form.Label.render/1","type":"function"},{"doc":"An input field that let the user to enter a number.Provides a wrapper for Phoenix.HTML.Form's number_input/3 function.All options passed via opts will be sent to number_input/3, value and class can be set directly and will override anything in opts.Examples&lt;NumberInput form=&quot;user&quot; field=&quot;age&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.NumberInput.html","title":"Surface.Components.Form.NumberInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.NumberInput.html#render/1","title":"Surface.Components.Form.NumberInput.render/1","type":"function"},{"doc":"An input field that let the user securely specify a password.Provides a wrapper for Phoenix.HTML.Form's password_input/3 function.All options passed via opts will be sent to password_input/3, value and class can be set directly and will override anything in opts.Examples&lt;PasswordInput form=&quot;user&quot; field=&quot;password&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.PasswordInput.html","title":"Surface.Components.Form.PasswordInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.PasswordInput.html#render/1","title":"Surface.Components.Form.PasswordInput.render/1","type":"function"},{"doc":"Defines a radio button.Provides a wrapper for Phoenix.HTML.Form's radio_button/4 function.All options passed via opts will be sent to radio_button/4, value and class can be set directly and will override anything in opts.Examples&lt;RadioButton form=&quot;user&quot; field=&quot;color&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.checked :boolean - Indicates whether or not the radio button is the selected item in the group.","ref":"Surface.Components.Form.RadioButton.html","title":"Surface.Components.Form.RadioButton","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.RadioButton.html#render/1","title":"Surface.Components.Form.RadioButton.render/1","type":"function"},{"doc":"An input field that let the user specify a numeric value in a given range, usually using a slider.Provides a wrapper for Phoenix.HTML.Form's range_input/3 function.All options passed via opts will be sent to range_input/3, value, min, max and class can be set directly and will override anything in opts.Examples&lt;RangeInput form=&quot;volume&quot; field=&quot;percent&quot; min=&quot;0&quot; max=&quot;100&quot; step=&quot;5&quot; value=&quot;40&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.min :string - Minimum value for the input.max :string - Maximum value for the input.step :string - Sets or returns the value of the step attribute of the slider control.","ref":"Surface.Components.Form.RangeInput.html","title":"Surface.Components.Form.RangeInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.RangeInput.html#render/1","title":"Surface.Components.Form.RangeInput.render/1","type":"function"},{"doc":"Defines a reset button.Provides a wrapper for Phoenix.HTML.Form's reset/2 function.All options passed via opts will be sent to reset/2, value and class can be set directly and will override anything in opts.Examples&lt;Reset value=&quot;Reset&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalue :string, default: &quot;Reset&quot; - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Keyword list with options to be passed down to reset/2.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.Reset.html","title":"Surface.Components.Form.Reset","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Reset.html#render/1","title":"Surface.Components.Form.Reset.render/1","type":"function"},{"doc":"An input field that let the user enter search queries.Provides a wrapper for Phoenix.HTML.Form's search_input/3 function.All options passed via opts will be sent to search_input/3, value and class can be set directly and will override anything in opts.Examples&lt;SearchInput form=&quot;song&quot; field=&quot;title&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.SearchInput.html","title":"Surface.Components.Form.SearchInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.SearchInput.html#render/1","title":"Surface.Components.Form.SearchInput.render/1","type":"function"},{"doc":"Defines a submit button to send the form.All options are forwarded to the underlying Phoenix.HTML.Form.submit/3Propertieslabel :string - The label to be used in the button.class :css_class - Class or classes to apply to the button.opts :keyword, default: [] - Keyword list with options to be passed down to submit/3.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.Submit.html","title":"Surface.Components.Form.Submit","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Submit.html#render/1","title":"Surface.Components.Form.Submit.render/1","type":"function"},{"doc":"An input field that let the user enter a telephone number.Provides a wrapper for Phoenix.HTML.Form's telephone_input/3 function.All options passed via opts will be sent to telephone_input/3, value, pattern and class can be set directly and will override anything in opts.Examples&lt;TelephoneInput form=&quot;user&quot; field=&quot;phone&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.TelephoneInput.html","title":"Surface.Components.Form.TelephoneInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TelephoneInput.html#render/1","title":"Surface.Components.Form.TelephoneInput.render/1","type":"function"},{"doc":"An input field that let the user enter a multi-line text.Provides a wrapper for Phoenix.HTML.Form's textarea/3 function.All options passed via opts will be sent to textarea/3. Explicitly defined properties like value and class can be set directly and will override anything in opts.Examples&lt;TextArea form=&quot;user&quot; field=&quot;summary&quot; cols=&quot;5&quot; rows=&quot;10&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.rows :string - Specifies the visible number of lines in a text area.cols :string - Specifies the visible width of a text area.","ref":"Surface.Components.Form.TextArea.html","title":"Surface.Components.Form.TextArea","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TextArea.html#render/1","title":"Surface.Components.Form.TextArea.render/1","type":"function"},{"doc":"An input field that let the user enter a single-line text.Provides a wrapper for Phoenix.HTML.Form's text_input/3 function.All options passed via opts will be sent to text_input/3, value and class can be set directly and will override anything in opts.Examples&lt;TextInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.TextInput.html","title":"Surface.Components.Form.TextInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TextInput.html#render/1","title":"Surface.Components.Form.TextInput.render/1","type":"function"},{"doc":"An input field that let the user enter a time (hours, minutes and optionally seconds).Provides a wrapper for Phoenix.HTML.Form's time_input/3 function.All options passed via opts will be sent to time_input/3, value and class can be set directly and will override anything in opts.Examples&lt;TimeInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.TimeInput.html","title":"Surface.Components.Form.TimeInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TimeInput.html#render/1","title":"Surface.Components.Form.TimeInput.render/1","type":"function"},{"doc":"An input field that let the user enter a URL.Provides a wrapper for Phoenix.HTML.Form's url_input/3 function.All options passed via opts will be sent to url_input/3, value and class can be set directly and will override anything in opts.Examples&lt;UrlInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesform :form - An identifier for the form.field :string - An identifier for the input.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.blur :event - Triggered when the component loses focus.focus :event - Triggered when the component receives focus.capture_click :event - Triggered when the component receives click.keydown :event - Triggered when a button on the keyboard is pressed.keyup :event - Triggered when a button on the keyboard is released.","ref":"Surface.Components.Form.UrlInput.html","title":"Surface.Components.Form.UrlInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.UrlInput.html#render/1","title":"Surface.Components.Form.UrlInput.render/1","type":"function"},{"doc":"Defines a hyperlink.Provides a wrapper for Phoenix.HTML.Link's link/2 function.All options passed via opts will be sent to link/2, label and class can be set directly and will override anything in opts.Examples&lt;Link label=&quot;user&quot; to=&quot;/users/1&quot; class=&quot;is-danger&quot; opts={{ method: :delete, data: [confirm: &quot;Really?&quot;] }} /&gt; &lt;Link to=&quot;/users/1&quot; class=&quot;is-link&quot; &gt; &lt;span&gt;user&lt;/span&gt; &lt;/Link&gt;Propertiesto :string, required: true - Place to link to.class :css_class - Class or classes to apply to the link.opts :keyword, default: [] - Keyword with options to be passed down to link/2.label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .click :event - Triggered on click.","ref":"Surface.Components.Link.html","title":"Surface.Components.Link","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Link.html#render/1","title":"Surface.Components.Link.render/1","type":"function"},{"doc":"Defines a link that will patch the current LiveView.Provides similar capabilities to Phoenix's built-in live_patch/2 function.When navigating to the current LiveView, handle_params/3 is immediately invoked to handle the change of params and URL state. Then the new state is pushed to the client, without reloading the whole page. For live redirects to another LiveView, use &lt;LiveRedirect&gt; instead.Propertiesto :string, required: true - The required path to link to.replace :boolean, default: false - The flag to replace the current history or push a new state.class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element.label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .","ref":"Surface.Components.LivePatch.html","title":"Surface.Components.LivePatch","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LivePatch.html#render/1","title":"Surface.Components.LivePatch.render/1","type":"function"},{"doc":"Defines a link that will redirect to a new LiveView.Provides similar capabilities to Phoenix's built-in live_redirect/2 function.The current LiveView will be shut down and a new one will be mounted in its place, without reloading the whole page. This can also be used to remount the same LiveView, in case you want to start fresh. If you want to navigate to the same LiveView without remounting it, use &lt;LivePatch&gt; instead.Propertiesto :string, required: true - The required path to link to.replace :boolean, default: false - The flag to replace the current history or push a new state.class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element.label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .","ref":"Surface.Components.LiveRedirect.html","title":"Surface.Components.LiveRedirect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LiveRedirect.html#render/1","title":"Surface.Components.LiveRedirect.render/1","type":"function"},{"doc":"A simple macro component that converts markdown into HTML at compile-time.Global configuration (optional)A set of global options you can set in config.exs. Available options are:default_class - The default CSS class for the wrapping &lt;div&gt;. It can be overridden using propety class.default_opts - The default set of options to be passed down to Earmark.as_html/2. It can be overridden using propety opts.CSS StylingSome CSS libs define their own styles for tags like &lt;p&gt;, &lt;ul&gt;, &lt;ol&gt;, &lt;strong&gt;, &lt;h1&gt; to &lt;h6&gt;, etc. This can make the rendered HTML look different from what you expect. One way to fix that is to customize the CSS class on the outer &lt;div&gt; of the generated code.For instance, in Bulma, you can use the class content to handle WYSIWYG content like the HTML generated by the Markdown component.You can have a default class applied globally using the default_class config:config :surface, :components, [ {Surface.Components.Markdown, default_class: &quot;content&quot;} ]Or you can set/override it individually for each &lt;#Markdown&gt; instance using the class property.Propertiesclass :string - The CSS class for the wrapping &lt;div&gt;.unwrap :boolean, default: false - Removes the wrapping &lt;div&gt;, if true.opts :keyword, default: [] - Keyword list with options to be passed down to Earmark.as_html/2.For a full list of available options, please refer to the Earmark.as_html/2 documentation. .","ref":"Surface.Components.Markdown.html","title":"Surface.Components.Markdown","type":"module"},{"doc":"A macro component that does not translate any of its contents.The content will be passed untouched to the underlying Phoenix's template engine.Note: By skipping translation, all Surface specific features are automatically disabled, including code interpolation with {{...}}, syntactic sugar for attributes and markup validation.Properties","ref":"Surface.Components.Raw.html","title":"Surface.Components.Raw","type":"module"},{"doc":"A live (stateless or stateful) component. A wrapper around Phoenix.LiveComponent.Exampledefmodule Dialog do use Surface.LiveComponent property title, :string, required: true def mount(socket) do {:ok, assign(socket, show: false)} end def render(assigns) do ~H&quot;&quot;&quot; &lt;div class={{ &quot;modal&quot;, &quot;is-active&quot;: @show }}&gt; &lt;div class=&quot;modal-background&quot;&gt;&lt;/div&gt; &lt;div class=&quot;modal-card&quot;&gt; &lt;header class=&quot;modal-card-head&quot;&gt; &lt;p class=&quot;modal-card-title&quot;&gt;{{ @title }}&lt;/p&gt; &lt;/header&gt; &lt;section class=&quot;modal-card-body&quot;&gt; &lt;slot/&gt; &lt;/section&gt; &lt;footer class=&quot;modal-card-foot&quot; style=&quot;justify-content: flex-end&quot;&gt; &lt;Button click=&quot;hide&quot;&gt;Ok&lt;/Button&gt; &lt;/footer&gt; &lt;/div&gt; &lt;/div&gt; &quot;&quot;&quot; end # Public API def show(dialog_id) do send_update(__MODULE__, id: dialog_id, show: true) end # Event handlers def handle_event(&quot;show&quot;, _, socket) do {:noreply, assign(socket, show: true)} end def handle_event(&quot;hide&quot;, _, socket) do {:noreply, assign(socket, show: false)} end end","ref":"Surface.LiveComponent.html","title":"Surface.LiveComponent","type":"behaviour"},{"doc":"This optional callback is invoked in order to set up a context that can be retrieved for any descendent component.","ref":"Surface.LiveComponent.html#c:init_context/1","title":"Surface.LiveComponent.init_context/1","type":"callback"},{"doc":"A wrapper component around Phoenix.LiveView.Since this module is just a wrapper around Phoenix.LiveView, you cannot define custom properties for it. Only :id and :session are available. However, built-in directives like :for and :if can be used normally.Exampledefmodule Example do use Surface.LiveView def render(assigns) do ~H&quot;&quot;&quot; &lt;Dialog title=&quot;Alert&quot; id=&quot;dialog&quot;&gt; This &lt;b&gt;Dialog&lt;/b&gt; is a stateful component. Cool! &lt;/Dialog&gt; &lt;Button click=&quot;show_dialog&quot;&gt;Click to open the dialog&lt;/Button&gt; &quot;&quot;&quot; end def handle_event(&quot;show_dialog&quot;, _, socket) do Dialog.show(&quot;dialog&quot;) {:noreply, socket} end end","ref":"Surface.LiveView.html","title":"Surface.LiveView","type":"module"},{"doc":"A low-level component which is responsible for translating its own content at compile time.","ref":"Surface.MacroComponent.html","title":"Surface.MacroComponent","type":"behaviour"},{"doc":"Evaluates the values of the properties of a macro component.Usually called inside translate/2 in order to retrieve the properties at compile-time.","ref":"Surface.MacroComponent.html#eval_static_props!/3","title":"Surface.MacroComponent.eval_static_props!/3","type":"function"},{"doc":"Tranlates the content of the macro component.","ref":"Surface.MacroComponent.html#c:translate/2","title":"Surface.MacroComponent.translate/2","type":"callback"},{"doc":"Defines a behaviour that must be implemented by all HTML/Surface node translators.This module also contains the main logic to translate Surface code.","ref":"Surface.Translator.html","title":"Surface.Translator","type":"behaviour"},{"doc":"","ref":"Surface.Translator.html#c:prepare/2","title":"Surface.Translator.prepare/2","type":"callback"},{"doc":"Translates a string written using the Surface format into a Phoenix template.","ref":"Surface.Translator.html#run/4","title":"Surface.Translator.run/4","type":"function"},{"doc":"Recursively translates nodes from a parsed surface code.","ref":"Surface.Translator.html#translate/2","title":"Surface.Translator.translate/2","type":"function"},{"doc":"","ref":"Surface.Translator.html#c:translate/2","title":"Surface.Translator.translate/2","type":"callback"},{"doc":"","ref":"Surface.Translator.ParseError.html","title":"Surface.Translator.ParseError","type":"exception"}]